class PNOptions {
	public var hungercnt : float;
	public var thirstcnt : float;
	public var fatiguecnt : float;
	public var currHunger : int;
	public var currThirst : int;
	public var currFatigue : int;
	
	public var lasttime : int;
	public var daychanged : int;
	public var timeinit : bool;
	
	public function SetF( val : float ) { fatiguecnt = val; }
	public function SetT( val : float ) { thirstcnt = val; }
	public function SetH( val : float ) { hungercnt = val; }
	public function SetFatigue( val : int ) { currFatigue = val; }
	public function SetHunger( val : int ) { currHunger = val; }
	public function SetThirst( val : int ) { currThirst = val; }
	
	public function SetDayChanged( val : int ) { daychanged = val; }
	public function SetLT( value : int) { lasttime = value; }
	public function SetTimeInit( val : bool ) { timeinit = val; }
	
	public function Init() {
		var temp : int;
		hungercnt = PNGetHungerCounter();
		thirstcnt = PNGetThirstCounter();
		fatiguecnt = PNGetFatigueCounter();
		
		currHunger = PNGetHungerLevel();
		currThirst = PNGetThirstLevel();
		currFatigue = PNGetFatigueLevel();
		
		daychanged = GameTimeDays(theGame.GetGameTime());
		lasttime = GameTimeToSeconds(theGame.GetGameTime()) / 60;
	}
}

function PNResetFatigueCnt() { theGame.PNOptions().SetF( PNGetFatigueCounter() ); }
function PNResetThirstCnt() { theGame.PNOptions().SetT( PNGetThirstCounter() ); }
function PNResetHungerCnt() { theGame.PNOptions().SetH( PNGetHungerCounter() ); }

function PNDecFatigueCnt( fat : float ) { theGame.PNOptions().SetF( PNGetFatigueCnt() - fat ); }
function PNDecThirstCnt( thr : float ) { theGame.PNOptions().SetT( PNGetThirstCnt() - thr ); }
function PNDecHungerCnt( hun : float ) { theGame.PNOptions().SetH( PNGetHungerCnt() - hun ); }

function PNGetFatigueCnt() : float { return theGame.PNOptions().fatiguecnt; }
function PNGetThirstCnt() : float { return theGame.PNOptions().thirstcnt; }
function PNGetHungerCnt() : float { return theGame.PNOptions().hungercnt; }

function PNSetHunger( val : int ) { 
	thePlayer.RemoveAbility(PNHungerToName(PNGetHunger()));
	if ( val > 100 ) val = 100;
	if ( val < 0 ) val = 0;
	thePlayer.AddAbility(PNHungerToName(val));
	theGame.PNOptions().SetHunger( val );
}
function PNSetThirst( val : int ) {
	thePlayer.RemoveAbility(PNThirstToName( PNGetThirst()));
	if ( val > 100 ) val = 100;
	if ( val < 0 ) val = 0;
	thePlayer.AddAbility( PNThirstToName(val));
	theGame.PNOptions().SetThirst( val );
}
function PNSetFatigue( val : int ) {
	thePlayer.RemoveAbility( PNFatigueToName( PNGetFatigue()) );
	if ( val > 100 ) val = 100;
	if ( val < 0 ) val = 0;
	thePlayer.AddAbility( PNFatigueToName(val) );
	theGame.PNOptions().SetFatigue( val );
}

function PNGetHunger() : int { return theGame.PNOptions().currHunger; };
function PNGetThirst() : int { return theGame.PNOptions().currThirst; };
function PNGetFatigue() : int { return theGame.PNOptions().currFatigue; };

function PNSetLastTime( val : int ) { theGame.PNOptions().SetLT( val ); }
function PNGetLastTime() : int { return theGame.PNOptions().lasttime; }

function PNTimeInit() : bool {
	if ( theGame.PNOptions().timeinit ) {
		theGame.PNOptions().SetTimeInit(false);
		return true;
	} else {
		return false;
	}
}

function PNIncDayChanged() { theGame.PNOptions().SetDayChanged( PNGetDayChanged() + 1 ); }
function PNGetDayChanged() : int { return theGame.PNOptions().daychanged; }

function PNTimePass() {
	var dayNow : int;
	var time : int;
	var diff : int;
	
	if( GetWitcherPlayer().IsMeditating() ) {
		PNSetMeditationFlag();
	}
	
	dayNow = GameTimeDays(theGame.GetGameTime());
	
	time = GameTimeToSeconds(theGame.GetGameTime()) / 60;
	diff = (time - PNGetLastTime());
	PNSetLastTime(time);
	
	if ( thePlayer.IsCiri() ) {
		if ( PNGetDayChanged() != dayNow) {
			PNIncDayChanged();
		}
		return;
	}
	
	if (PNExpireOn()) {
		if ( PNGetDayChanged() != dayNow) {
			PNDecrementDay();
			PNIncDayChanged();
		}
	}
	
	if (PNHungerOn()) {
		PNRiseHunger( diff );
		if ( PNGetHungerCnt() <= 0 ) {
			PNSetHunger( PNGetHunger() + 1 );
			PNResetHungerCnt();
		}
	}
	
	if (PNThirstOn()) {
		PNRiseThirst( diff );
		if ( PNGetThirstCnt() <= 0 ) {
			PNSetThirst( PNGetThirst() + 1 );
			PNResetThirstCnt();
		}
	}
	
	if (PNFatigueOn()) {
		PNRiseFatigue( diff );
		if ( PNGetFatigueCnt() <= 0 ) {
			PNSetFatigue( PNGetFatigue() + 1 );
			PNResetFatigueCnt();
		}
	}
	
	if ( PNPeekMeditationFlag() ) {
		PNResetMeditationFlag();
	}
	
}