function PNRiseHunger( diff : int ) {
	if ( diff > 1 ) {
		if (!PNPeekMeditationFlag()) {
			if (diff / PNGetHungerCounter() >= PNGetHungerMaxFastTravel()) {
				diff = PNGetHungerMaxFastTravel() * PNGetHungerCounter();
			}
		}
		PNFeed( RoundMath(((float) diff / (float) PNGetHungerCounter()) * ( -1 ) * PNGetHungerMeditationMult()));
	} else {
		PNDecHungerCnt( PNGetHungerInc() );
	}
}

function PNGetHungerInc() : float {
	var combatadd : float;
	var healthadd : float;
	var totaladd : float;
	var staminaadd : float;
	var adrenalineadd : float;
	var toxadd : float;
	
	combatadd = 0;
	if ( thePlayer.IsInCombat() ) {
		combatadd = PNGetHungerCombatAdd();
	}
	healthadd = (1 - (thePlayer.GetStat(BCS_Vitality) / thePlayer.GetStatMax(BCS_Vitality))) * PNGetHungerVitalityAdd();
	staminaadd = (1 - (thePlayer.GetStat(BCS_Stamina) / thePlayer.GetStatMax(BCS_Stamina))) * PNGetHungerStaminaAdd();
	adrenalineadd = (1 - (thePlayer.GetStat(BCS_Focus) / thePlayer.GetStatMax(BCS_Focus))) * PNGetHungerAdrenalineAdd();
	toxadd = (thePlayer.GetStat(BCS_Toxicity) / thePlayer.GetStatMax(BCS_Toxicity)) * PNGetHungerToxAdd();
	totaladd = 1 + combatadd + healthadd + staminaadd + adrenalineadd - toxadd;
	if (totaladd < 0) { totaladd = 0; } 
	return totaladd;
}

function PNFeed( fed : int ) {
	var over : int;
	if ( PNHungerOn() ) {
		over = PNGetHunger() - fed;
		if ( over < 0 ) {
			PNSetFatigue( PNGetFatigue() - over);
		}
		PNSetHunger( PNGetHunger() - fed );
		PNResetHungerCnt();
	}
}
